#20-08-2021

import matplotlib.pyplot as plt
from random import randint
from random import random
import random
from sklearn.metrics import mean_absolute_percentage_error
import copy

########################################################   Simulations (number of infections)

def Interaction(Pop0,betau,betav,kappa,occup):
    m=len(Pop0)
    Pop=copy.deepcopy(Pop0)

    for i in range (int(occup*m)):
        if Pop[i][1]==0: #Unvaccine individuals
            k=0
            while k<kappa:
                j=randint(0,int(occup*m)-1)
                while i==j:
                    j=randint(0,int(occup*m)-1)
                r=random.random()
                if(r<=betau):
                    Pop0[i][0]=Pop0[i][0]*Pop0[j][0]
                k=k+1
        else:#Pop[i][1]==1:
            k=0
            while k<kappa:
                j=randint(0,int(occup*m)-1)
                while i==j:
                    j=randint(0,int(occup*m)-1)
                r=random.random()
                if(r<=betav):
                    Pop0[i][0]=Pop0[i][0]*Pop0[j][0]
                k=k+1

    return Pop0

def One_round_Simul(n,nv,betau,betav,kappa,occup,T):
    Y=list()
    Pop=list()
    for i in range (n):
        Pop.append([1,0])  #The first element shows the employee is healty (1) or infected (0)
                            # The second element shows he got the vaccin (1)  or not (0)
    r=randint(0,n-1)
    Pop[r][0]=0
    Y.append(1)

    i=0
    while i<nv:
        r=randint(0,n-1)
        if Pop[r][1]==0:
            Pop[r][1]=1  # vaccinated
            i=i+1

    for t in range (1,T):
        random.shuffle(Pop)
        Pop=Interaction(Pop,betau,betav,kappa,occup)
        s=0
        for i in range(n):
            if Pop[i][0]==0:
                s=s+1
        Y.append(s)

    return Y

def Simulations(n,nv,betau,betav,kappa,occup,T):
    repeat=100
    Y=list()
    Y=One_round_Simul(n,nv,betau,betav,kappa,occup,T)
    
    for i in range (0,repeat-1):
        Y2=list()
        Y2.clear()
        Y2=One_round_Simul(n,nv,betau,betav,kappa,occup,T)
        for j in range(len(Y)):
            Y[j]=Y[j]+Y2[j]
    
    for j in range (0,len(Y)):
        Y[j]=Y[j]/repeat

    return(Y)

########################################################   Accum Simulations (Acculated number of infections)

def Accum_Interaction(Pop,betau,betav,kappa,occup):
    m=len(Pop)
    for i in range (int(occup*m)):
        if Pop[i][1]==0: #Unvaccine individuals
            k=0
            while k<kappa:
                j=randint(0,int(occup*m)-1)
                r=random.random()
                if(r<=betau):
                    Pop[i][0]=Pop[i][0]*Pop[j][0]
                k=k+1
        else:#Pop[i][1]==1:
            k=0
            while k<kappa:
                j=randint(0,int(occup*m)-1)
                r=random.random()
                if(r<=betav):
                    Pop[i][0]=Pop[i][0]*Pop[j][0]
                k=k+1

    return Pop

def Accum_One_round_Simul(n,nv,betau,betav,kappa,occup,Ih,T):
    Y=list()
    Pop=list()
    for i in range (n):
        Pop.append([1,0])  #The first element shows the employee is healty (1) or infected (0)
                            # The second element shows he got the vaccin (1)  or not (0)
    r=random.random()
    if r<=Ih:
        j=randint(0,n-1)
        Pop[j][0]=0
        Y.append(1)
    else:
        Y.append(0)

    i=0
    while i<nv:
        r=randint(0,n-1)
        if Pop[r][1]==0:
            Pop[r][1]=1  # vaccinated
            i=i+1

    for t in range (1,T):
        random.shuffle(Pop)
        Pop=Accum_Interaction(Pop,betau,betav,kappa,occup)
        s=0
        for i in range(n):
            if Pop[i][0]==0:
                s=s+1
        Y.append(s)
        r=random.random()
        if r<=Ih:
            try_to_do=0
            j=randint(0,n-1)
            while (Pop[j][0] ==1 and try_to_do<50): # 50 times try to intrduce a new infection
                j=randint(0,n-1)
                try_to_do=try_to_do+1
            Pop[j][0]=0


    return Y

def Accum_Simulations(n,nv,betau,betav,kappa,occup,Ih,T):
    repeat=30
    Y=list()
    Y=Accum_One_round_Simul(n,nv,betau,betav,kappa,occup,Ih,T)
    
    for i in range (0,repeat-1):
        Y2=list()
        Y2.clear()
        Y2=Accum_One_round_Simul(n,nv,betau,betav,kappa,occup,Ih,T)
        for j in range(len(Y)):
            Y[j]=Y[j]+Y2[j]
    
    for j in range (0,len(Y)):
        Y[j]=Y[j]/repeat

    return(Y)

def Accum_Vaccin_Expected_Number_of_Infection(n,nv,betau,betav,kappa,occup,Ih,T):
    Y=list()
    #Y.append(1/n)#convert to percent
    Y.append(1)
    pu=0*betau*occup*occup*kappa*(1/(n-1)/2) # The reason behind of this initial value is the real-world behaviours
    pv=0*betav*occup*occup*kappa*(1/(n-1)/2) 
    # It is (highly) possible the employees is infected using a middle employee in the FIRST day. So,
    # This initialization is the probability of infection per (middle) employee before meeting another employee

    for d in range(1,T):
        A=pow(1-betau,occup*occup*kappa*(1/(n-1)))
        B=pow(1-pu*betau,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
        C=pow(1-pv*betau,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
        Pr_Healty= (A*B*C)*(1-pu)   # (1-pu) is the probability remaining health till day yesterday (d-1) and (ABC)
        pu=1-Pr_Healty

        A=pow(1-betav,occup*occup*kappa*(1/(n-1)))
        B=pow(1-pu*betav,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
        C=pow(1-pv*betav,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
        Pr_Healty= (A*B*C)*(1-pv)
        pv=1-Pr_Healty

        m=1+(n-nv-1)*pu+(nv*pv)
        #m=m/n #convert to percent
        Y.append(m*Ih)
    for i in range(1,len(Y)): # Computing accumulative number of infections (remove overlaps)
        Y[i]=Y[i]+Y[i-1]-((Y[i]*Y[i-1])/n)
    return Y
    # no noeed to Accum_Func anymore by the above calculations
    Y2=list()
    for i in range (0,len(Y)):
        Temp=list()
        Temp.clear()
        for j in range(0,i+1):
            Temp.append(Y[j])
        Y2.append(Accum_Func(Temp,n))

    return Y2

################################                    

################################                            Probabilistic Analysis (number of Infections)
# Send this function to Adam1-occup
def Vaccin_Expected_Number_of_Infection(n,nv,betau,betav,kappa,occup,T):
    Y=list()
    #Y.append(1/n)#convert to percent
    Y.append(1)
    pu=betau*occup*kappa*(1/(n-1)) # The reason behind of this initial value is the real-world behaviours
    pv=betav*occup*kappa*(1/(n-1))
    #pu=0
    #pv=0
    # It is (highly) possible the employees is infected using a middle employee in the FIRST day. So,
    # This initialization is the probability of infection per (middle) employee before meeting another employee

    for d in range(1,T):
        A=pow(1-betau,occup*occup*kappa*(1/(n-1)))
        B=pow(1-pu*betau,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
        C=pow(1-pv*betau,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
        Pr_Healty= (A*B*C)*(1-pu)   # (1-pu) is the probability remaining health till day yesterday (d-1) and (ABC)
        pu=1-Pr_Healty

        A=pow(1-betav,occup*occup*kappa*(1/(n-1)))
        B=pow(1-pu*betav,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
        C=pow(1-pv*betav,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
        Pr_Healty= (A*B*C)*(1-pv)
        pv=1-Pr_Healty


        m=1+(n-nv-1)*pu+(nv*pv)
        #m=m/n #convert to percent
        Y.append(m)
    return Y

################################################################################################################

def Accum_Func(A,n):
    l=len(A)
    if l==1:
        return A[0]
    if l==2:
        return A[0]+A[1]-((A[0]*A[1])/n)
    a=A[0]
    B=list()
    for i in range(1,l):
        B.append(A[i])
    b=Accum_Func(B,n)

    return ((a+b)-((a*b)/n))

def Comput_expected_detected_time(n,nv,betau,betav,occup,kappa,Ih,T):
    if T<=2:
        return 2  # There is a fact: if some infection arrives to the facility, at least 2 days need to be detected by tests

    #T=50
    #occup=0.9

    n_infect_list=list()
    pu=betau*occup*occup*kappa*(1/(n-1)/2) # The reason behind of this initial value is the real-world behaviours
    pv=betav*occup*occup*kappa*(1/(n-1)/2)
    # It is (highly) possible the employees is infected using a middle employee in the FIRST day. So,
    # This initialization is the probability of infection per (middle) employee before meeting another employee

    for d in range(1,T+1):
        A=pow(1-betau,occup*occup*kappa*(1/(n-1)))
        B=pow(1-pu*betau,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
        C=pow(1-pv*betau,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
        Pr_Healty= (A*B*C)*(1-pu)   # (1-pu) is the probability remaining health till day yesterday (d-1) and (ABC)
        pu=1-Pr_Healty

        A=pow(1-betav,occup*occup*kappa*(1/(n-1)))
        B=pow(1-pu*betav,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
        C=pow(1-pv*betav,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
        Pr_Healty= (A*B*C)*(1-pv)
        pv=1-Pr_Healty

        m=1+(n-nv-1)*pu+(nv*pv)
        n_infect_list.append(m*Ih)
    
    for i in range(1,len(n_infect_list)): # Computing accumulative number of infections (remove overlaps)
        n_infect_list[i]=n_infect_list[i]+n_infect_list[i-1]-((n_infect_list[i]*n_infect_list[i-1])/n)

    P_t=list()
    for i in range(0,len(n_infect_list)): # Computing accumulative infection probability
        P_t.append(n_infect_list[i]/n)

    k=n/T
    tau_bar=1-pow(1-P_t[0],k)
    for t in range(1,T):
        s=1
        for tp in range (0,t):
            s=s*pow(1-P_t[tp],k)
        tau_bar=tau_bar+s*(t)*(1-pow(1-P_t[t],k))

    if tau_bar<2:
        tau_bar=2
    return tau_bar

def Optimal_Presence(n,nv,betau,betav,contact_rate,prod,Ih,T):
    Opt_Presence_rate=list() # optimal percentage rate
    Opt_Productivity=list() # optimal productivity

    Opt_Presence_rate.append(100)
    Opt_Productivity.append(n)
    
    for t in range(1,T): # average test intervals
        Best_prod=-1
        Best_pr=-1
        tau_bar=1
        for pr in range(1,101):
            occup=pr/100
            kappa=10+((contact_rate)*occup*n)  #  5 constact is a constant plus some percentage of presented staff
            if contact_rate<=0.05 and kappa>40:
                kappa=40
            if contact_rate<=0.15 and kappa>70:
                kappa=70
            if contact_rate<=0.25 and kappa>100:
                kappa=100
            
            scale=8 # Divide a day into scale interval time such that (kappa/scale) contacts per intervl is possible
            kappa=kappa/scale

            #option 1:
            #temp=1+Comput_expected_detected_time(n,nv,betau,betav,occup,kappa,Ih,scale*t)
            #if temp>=tau_bar:
            #    tau_bar=temp

            #ption 2:
            ####################### Note: Do analysis for (day/scale) intervals and kappa/scale contacts
            tau_bar=scale*(t/2)+1
            ####################### Note: Do analysis for (day/scale) intervals and kappa/scale contacts

            pu=betau*occup*occup*kappa*(1/(n-1)/2) # The reason behind of this initial value is the real-world behaviours
            pv=betav*occup*occup*kappa*(1/(n-1)/2)
            # It is (highly) possible the employees is infected using a middle employee in the FIRST day. So,
            # This initialization is the probability of infection per (middle) employee before meeting another employee
            Accum_infected=1
            n_infect_list=list()
            if(tau_bar<1):
                m=1+(n-nv-1)*pu+(nv*pv)
                n_infect_list.append(m*Ih)

            for d in range(1,int(tau_bar)+1):
                A=pow(1-betau,occup*occup*kappa*(1/(n-1)))
                B=pow(1-pu*betau,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
                C=pow(1-pv*betau,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
                Pr_Healty= (A*B*C)*(1-pu)   # (1-pu) is the probability remaining health till day yesterday (d-1) and (ABC)
                pu=1-Pr_Healty

                A=pow(1-betav,occup*occup*kappa*(1/(n-1)))
                B=pow(1-pu*betav,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
                C=pow(1-pv*betav,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
                Pr_Healty= (A*B*C)*(1-pv)
                pv=1-Pr_Healty

                m=1+(n-nv-1)*pu+(nv*pv)
                n_infect_list.append(m*Ih)
            
            for i in range(1,len(n_infect_list)): # Computing accumulative number of infections (remove overlaps)
                n_infect_list[i]=n_infect_list[i]+n_infect_list[i-1]-((n_infect_list[i]*n_infect_list[i-1])/n)
            Accum_infected=n_infect_list[len(n_infect_list)-1]
            #Accum_infected=Accum_Func(n_infect_list,n)

            current_prod= occup*(n - Accum_infected) + prod*(1-occup)*(n - Accum_infected)

            if(Best_prod<current_prod):
                Best_prod=current_prod
                Best_pr=occup
        Opt_Presence_rate.append(Best_pr*100)
        Opt_Productivity.append(Best_prod)

    return Opt_Presence_rate,Opt_Productivity

def Optimal_Presence_paper_impact(n,nv,betau,betav,contact_rate,prod,Ih,t):
    Presence_rate=list() 
    Productivity=list()

    
    for pr in range(1,101):
        occup=pr/100
        kappa=5+int((contact_rate)*occup*n)  #  5 constact is a constant plus some percentage of presented staff
        if contact_rate==0.05 and kappa>40:
            kappa=40
        if contact_rate==0.12 and kappa>70:
            kappa=70
        if contact_rate==0.20 and kappa>100:
            kappa=100

        tau_bar=int(2*t/3)+1

        pu=betau*occup*occup*kappa*(1/(n-1)) # The reason behind of this initial value is the real-world behaviours
        pv=betav*occup*occup*kappa*(1/(n-1)) 
        Accum_infected=0
        n_infect_list=list()

        for d in range(1,tau_bar+1):
            A=pow(1-betau,occup*occup*kappa*(1/(n-1)))
            B=pow(1-pu*betau,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
            C=pow(1-pv*betau,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
            Pr_Healty= (A*B*C)*(1-pu)   # (1-pu) is the probability remaining health till day yesterday (d-1) and (ABC)
            pu=1-Pr_Healty

            A=pow(1-betav,occup*occup*kappa*(1/(n-1)))
            B=pow(1-pu*betav,(kappa*(1-(1/(n-1))))*occup*((n-nv-1)/(n-1)))
            C=pow(1-pv*betav,(kappa*(1-(1/(n-1))))*occup*(nv/(n-1)))
            Pr_Healty= (A*B*C)*(1-pv)
            pv=1-Pr_Healty

            m=1+(n-nv-1)*pu+(nv*pv)
            n_infect_list.append(m)

        Accum_infected=n_infect_list[len(n_infect_list)-1]
        j=int((d+1)/2)+1
        Accum_infected=Ih*(Accum_infected+Accum_infected*Ih*(j-1))
        
        if(Accum_infected>n):
            Accum_infected=n
        current_prod= occup*(n - Accum_infected) + prod*(1-occup)*(n - Accum_infected)

        Presence_rate.append(occup*100)
        Productivity.append(current_prod/n)

    return Presence_rate,Productivity

############################################################################################

def Impact_Figure(n,nv,betau,betav,Low_contacts,efficiency_param,Ih,t):
    #  IMPACT figure in the paper
    t=t # tau parameter: average test interval
    Y1,Z1=Optimal_Presence_paper_impact(n,nv,betau,betav,Low_contacts,efficiency_param,Ih,t)  #  Contact percentage, Low: about 5 percent
    #Y2,Z2=Optimal_Presence_paper_impact(n,nv,betau,betav,mid_contacts,efficiency_param,Ih,t)  #  Contact percentage, Medium: about 12 percent
    Y3,Z3=Optimal_Presence_paper_impact(n,nv,betau,betav,high_contacts,efficiency_param,Ih,t)  #  Contact percentage, High: about 20 percent
    
    T=100

    X=list()
    for j in range(0,T):
        X.append(j)

    fig, ax = plt.subplots()
    ax.plot(X, Y1, '-b', label="Low rate of contacts, 7% <40")
    #ax.plot(X, Y2, '-.o', label="Medium rate of contacts, 15% <70")
    ax.plot(X, Y3, '--r',  label="High rate of contacts, 25% <100 ")

    # naming the x axis
    plt.xlabel('Test Interval')
    # naming the y axis
    plt.ylabel('Optimal persence rate (%)')

    plt.title("n={0}, #nv={1}, βu={2}, prod={3}".format(n,nv,betau,efficiency_param))
    plt.xlim(0, T)
    plt.grid(b=None, which='major', axis='both')
    leg = ax.legend()

    fig, ax2 = plt.subplots()
    plt.xlabel('Test Interval')
    # naming the Y axis
    plt.ylabel('Optimal Productivity')
    ax2.plot(X, Z1, '-b', label="Low rate of contacts, 7% <40")
    #ax2.plot(X, Z2, '-.o', label="Medium rate of contacts, 15% <70")
    ax2.plot(X, Z3, '--r',  label="High rate of contacts, 25%  <100")
    plt.title("n={0}, #nv={1}, βu={2}, prod={3}".format(n,nv,betau,efficiency_param))
    plt.xlim(0, T)
    plt.grid(b=None, which='major', axis='both')
    leg = ax2.legend()
    plt.show()

##########################################################################################
##############  Comparing Number of Infections
def Comparing_number_of_Infections(n,nv,betau1,betav1,betau2,betav2,betau3,betav3,contact_rate,efficiency_param,Ih,T):
    occup=0.9
    kappa=10+int((contact_rate)*occup*n)  #  10 constact is a constant plus some percentage of presented staff

    Z1=Simulations(n,nv,betau1,betav1,kappa,occup,T)  #  Running Simulations for betau1-betau2
    Z2=Simulations(n,nv,betau2,betav2,kappa,occup,T)  
    Z3=Simulations(n,nv,betau3,betav3,kappa,occup,T) 
                                                                    #  Running Probabilistic analysis for betau1-betau2
    Y1=Vaccin_Expected_Number_of_Infection(n,nv,betau1,betav1,kappa,occup,T)  
    Y2=Vaccin_Expected_Number_of_Infection(n,nv,betau2,betav2,kappa,occup,T) 
    Y3=Vaccin_Expected_Number_of_Infection(n,nv,betau3,betav3,kappa,occup,T)  


    #####################################  Drawing the result diagrams
    X=list()                     
    for j in range(0,T):
        X.append(j)

    fig, ax = plt.subplots()
    ax.plot(X, Z1, 'og', label="Simulation results,βu={0}".format(betau1))
    ax.plot(X, Z2, 'ob', label="Simulation results,βu={0}".format(betau2))
    ax.plot(X, Z3, 'or',  label="Simulation results,βu={0}".format(betau3))

    ax.plot(X, Y1, '-g', label="Probabilistic analysis,βu={0}".format(betau1))
    ax.plot(X, Y2, '-b', label="Probabilistic analysis,βu={0}".format(betau2))
    ax.plot(X, Y3, '-r',  label="Probabilistic analysis,βu={0}".format(betau3))

    MAPD1=mean_absolute_percentage_error(Z1,Y1)
    MAPD2=mean_absolute_percentage_error(Z2,Y2)
    MAPD3=mean_absolute_percentage_error(Z3,Y3)
    #sum=0
    #for i in range(len(Z1)):
    #    sum=sum+(abs(Z1[i]-Y1[i])/Z1[i])
    #sum=sum/len(Z1)
    #print("sum=",sum)

    print(MAPD1,MAPD2,MAPD3)


    # naming the x axis
    plt.xlabel('∆t: Number of days after the infection arrives at the facility',fontsize=13)
    # naming the y axis
    plt.ylabel('Expected number of infected employees',fontsize=14)

    plt.title("n={0},κ={1}, nv={2}, occup={3}".format(n,kappa,nv,occup),fontsize=14)
    plt.xlim(0, T)
    #plt.ylim(0, 1)# convert to percent
    plt.grid(b=None, which='major', axis='both')
    leg = ax.legend()
    plt.show()

def Comparing_number_of_Accum_Infections(n,nv,betau1,betav1,betau2,betav2,betau3,betav3,contact_rate,efficiency_param,Ih,T):
    occup=0.9
    kappa=10+int((contact_rate)*occup*n)  #  8 constact is a constant plus some percentage of presented staff
    if contact_rate<0.07 and kappa>40:
        kappa=40
    if contact_rate<0.15 and kappa>70:
        kappa=70
    if contact_rate<0.25 and kappa>100:
        kappa=100

    Z1=Accum_Simulations(n,nv,betau1,betav1,kappa,occup,Ih,T)  #  Running Simulations for betau1-betau2
    Z2=Accum_Simulations(n,nv,betau2,betav2,kappa,occup,Ih,T)  
    Z3=Accum_Simulations(n,nv,betau3,betav3,kappa,occup,Ih,T) 
                                                                    #  Running Probabilistic analysis for betau1-betau2
    Y1=Accum_Vaccin_Expected_Number_of_Infection(n,nv,betau1,betav1,kappa,occup,Ih,T)  
    Y2=Accum_Vaccin_Expected_Number_of_Infection(n,nv,betau2,betav2,kappa,occup,Ih,T) 
    Y3=Accum_Vaccin_Expected_Number_of_Infection(n,nv,betau3,betav3,kappa,occup,Ih,T)  


    #####################################  Drawing the result diagrams
    X=list()                     
    for j in range(0,T):
        X.append(j)

    fig, ax = plt.subplots()
    ax.plot(X, Z1, 'og', label="Simulation results,βu={0}".format(betau1))
    ax.plot(X, Z2, 'ob', label="Simulation results,βu={0}".format(betau2))
    ax.plot(X, Z3, 'or',  label="Simulation results,βu={0}".format(betau3))

    ax.plot(X, Y1, '-g', label="Probabilistic analysis,βu={0}".format(betau1))
    ax.plot(X, Y2, '-b', label="Probabilistic analysis,βu={0}".format(betau2))
    ax.plot(X, Y3, '-r',  label="Probabilistic analysis,βu={0}".format(betau3))

    MAPD1=mean_absolute_percentage_error(Z1,Y1)
    MAPD2=mean_absolute_percentage_error(Z2,Y2)
    MAPD3=mean_absolute_percentage_error(Z3,Y3)
    print(MAPD1,MAPD2,MAPD3)


    # naming the x axis
    plt.xlabel('∆t: Number of days after the infection arrives at the facility')
    # naming the y axis
    plt.ylabel('Expected number of infected employees')

    plt.title("n={0},κ={1}, nv={2}, occup={3}".format(n,kappa,nv,occup))
    plt.xlim(0, T)
    #plt.ylim(0, 1)# convert to percent
    plt.grid(b=None, which='major', axis='both')
    leg = ax.legend()
    plt.show()

###################################################################################################################
############  Optimal presence rate

def Probabilistic_Analysis_Approach(n,nv,betau,betav,Low_contacts,mid_contacts,high_contacts,efficiency_param,Ih,T):
    Y1,Z1=Optimal_Presence(n,nv,betau,betav,Low_contacts,efficiency_param,Ih,T)  #  Contact percentage, Low: about 5 percent
    Y2,Z2=Optimal_Presence(n,nv,betau,betav,mid_contacts,efficiency_param,Ih,T)  #  Contact percentage, Medium: about 12 percent
    Y3,Z3=Optimal_Presence(n,nv,betau,betav,high_contacts,efficiency_param,Ih,T)  #  Contact percentage, High: about 20 percent

    X=list()
    for j in range(0,T):
        X.append(j)

    fig, ax = plt.subplots()
    ax.plot(X, Y1, '-b', label="Low rate of contacts, 7% <40")
    ax.plot(X, Y2, '-.o', label="Medium rate of contacts, 15% <70")
    ax.plot(X, Y3, '--r',  label="High rate of contacts, 25% <100 ")

    # naming the x axis
    plt.xlabel('Test Interval')
    # naming the y axis
    plt.ylabel('Optimal persence rate (%)')

    plt.title("n={0}, #nv={1}, βu={2}, prod={3}".format(n,nv,betau,efficiency_param))
    plt.xlim(0, T)
    plt.grid(b=None, which='major', axis='both')
    leg = ax.legend()

    fig, ax2 = plt.subplots()
    plt.xlabel('Test Interval')
    # naming the Y axis
    plt.ylabel('Optimal Productivity')
    ax2.plot(X, Z1, '-b', label="Low rate of contacts, 7% <40")
    ax2.plot(X, Z2, '-.o', label="Medium rate of contacts, 15% <70")
    ax2.plot(X, Z3, '--r',  label="High rate of contacts, 25%  <100")
    plt.title("n={0}, #nv={1}, βu={2}, prod={3}".format(n,nv,betau,efficiency_param))
    plt.xlim(0, T)
    plt.grid(b=None, which='major', axis='both')
    leg = ax2.legend()
    plt.show()

################################################################################################################
####################################  Input parameters
T=15       # Time interval : T is the maximum test interval, i.e., 14 days

n=150         #number of employees
nv=80        # number of vaccinated employees

efficiency_param=0.85    # HO  or prod, Rate of efficiency for home office staffs comparing presenting in the facility
Ih= 0.1+n*0.0001          #  Probability of infection arrives at the facility in one day for 100 percent presence rate
if Ih> 1:
    Ih=1
                         # Also, Ih can be interpret as the manager's risk for infection of the facility
Low_contacts=0.10
mid_contacts=0.15
high_contacts=0.25
# assume one case for transmission rate, betau1, betau2 and betau3 
betau=0.08
betav=(1-0.85)*betau  #  we assume a 85 percent imuunity for the vaccinated employees

betau1=0.05
betav1=(1-0.85)*betau  #  we assume a 85 percent imuunity for the vaccinated employees
betau2=0.1
betav2=(1-0.85)*betau  
betau3=0.15
betav3=(1-0.85)*betau  

######################################   end of input area

#Functions area:


Comparing_number_of_Infections(n,nv,betau1,betav1,betau2,betav2,betau3,betav3,Low_contacts,efficiency_param,Ih,T)

#Comparing_number_of_Accum_Infections(n,nv,betau1,betav1,betau2,betav2,betau3,betav3,Low_contacts,efficiency_param,Ih,T)

#Impact_Figure(n,nv,betau,betav,Low_contacts,efficiency_param,Ih,t=10)

#Probabilistic_Analysis_Approach(n,nv,betau,betav,Low_contacts,mid_contacts,high_contacts,efficiency_param,Ih,T)